//+------------------------------------------------------------------+
//|                                                   ADXcrosses.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
double bs,br;
int    nShift,up,dn;   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    SetIndexStyle(0, DRAW_ARROW, 0, 1);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
//----
    SetIndexStyle(1, DRAW_ARROW, 0, 1);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
//---- name for DataWindow and indicator subwindow label
    IndicatorShortName("Break in Sup/res");
    SetIndexLabel(0, "supup");
    SetIndexLabel(1, "supdn"); 
//----
    switch(Period())
      {
        case     1: nShift = 1;   break;    
        case     5: nShift = 3;   break; 
        case    15: nShift = 5;   break; 
        case    30: nShift = 10;  break; 
        case    60: nShift = 15;  break; 
        case   240: nShift = 20;  break; 
        case  1440: nShift = 80;  break; 
        case 10080: nShift = 100; break; 
        case 43200: nShift = 200; break;               
      }
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
//----
    for(int i = 0; i < limit; i++)
      {
        br=iCustom(NULL,0,"support and resistance (barry)1",0,i);
        bs=iCustom(NULL,0,"support and resistance (barry)1",1,i);
       // Comment (br,"     ",bs,"      ",Open[i]);
       ExtMapBuffer1[i]=0;
       ExtMapBuffer2[i]=0;
        if(Open[i]>br && Open[i]>bs  )
        {
            ExtMapBuffer1[i] = Low[i] - nShift*Point;
            up=1;
        }    
        //----
       if(Open[i]<br && Open[i]<bs ) 
       {
           ExtMapBuffer2[i] = High[i] + nShift*Point;
          dn=1;
       }    
       // Comment (br,"     ",bs,"      ",Open[i],"  ",ExtMapBuffer1[i+1]);
      }
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
           int whichBar = 0;
        else   whichBar = 1;
        if (ExtMapBuffer1[whichBar] > 0) doAlert(" UP trend");
        if (ExtMapBuffer2[whichBar] > 0) doAlert(" DOWN trend");
      }    
    
    return(0);
  }
//+------------------------------------------------------------------+
 //+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SUpRes Breakout ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SUpRes Breakout "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

 

